
// King Of Frogs
// Beta 1.0
// by Clemens Mckel
// works with Lite-C 1.07 (A7.07) and higher
//
////////////////////////////////////////////

#include <acknex.h>
#define PRAGMA_PATH "Source\\Bitmaps"
#define PRAGMA_PATH "Source\\CodeExtra
#define PRAGMA_PATH "Source\\Maps"
#define PRAGMA_PATH "Source\\Sounds"
#define PRAGMA_PATH "Source\\Sounds\\Texture"

// //////////////////////////

/// Dynamische Variablen
var Rivale_Nr, Sprung_Nr,
	 Rennen_aktiv, Stoppuhr,
	 Ziellinie_absolut, Theme_handle,
	 MapSpielerKontrolle_i,
// Bewegungsspeicher
	 SpSAVE_Siegerzeit_i, SpSAVE_Sprunganzahl_i, SpSAVE_Spruenge_i[37][2],
	 RiLOAD_Siegerzeit[6], RiLOAD_Sprunganzahl[6], RiLOAD_Spruenge[37][2][6],
// Parameter
	 LEFTSIDE = -1,
	 SCREENRES = 1,
	 LEVEL = 1,
	 THEME = 1,
	 HQSHADOW = 0,
// other
	 dummy;
#define mouse_force_x -mouse_force.x * sign(LEFTSIDE)			// Fr Linkshnder! // sign damits nur -1 oder 1 (leider auch 0) annehmen kann
#define mickey_x -mickey.x * sign(LEFTSIDE)

/// SKILL/FLAG-Entity-Variablen
// Eigenschaften (alle)
#define _Rivale_Nr skill1
#define _Sprung_Nr skill21
#define _Bew_ImSprung FLAG1
#define _Bew_Sprunghoehe_max skill22
#define _Bew_StreckenRest skill23
#define _Bew_SprungBahnHoehe skill24
#define _Mausbewegungsdauer skill25
#define _Fehlbewegung skill26
#define _Motivation skill27
#define _Power skill28
#define _PowerRegul skill29
#define _Sprungweite skill30	// fr die Speicherung von Nten
#define _PowerSound skill31

#define mouseforce_positiv clamp(mouse_force_x,0,2)
#define wait_for_reset(statement1,statement2) while(statement1.flags & statement2) wait(1)

/// Universal-Funktion(en) / Sole cheating/tricky method for sparing Semicolons!
function v(var* v1, n1, var* v2, n2, var* v3, n3) {
	v1[0]=n1;
	v2[0]=n2;
	v3[0]=n3;
}

STRING* SAVE_Siegername="";

////////////////////////////


PANEL* Logo = {
	bmap = "LogoWelcome.pcx";
	alpha = 100;
	flags =  VISIBLE, OVERLAY, TRANSLUCENT;
} // 3 Semis

PANEL* Statusanzeige = {
	digits(35, 25, "Motivation: %0.f", "laCartoonerie#48", 1, player.skill27);
	digits(35, 65, "Power: %0.f", "laCartoonerie#48", 1, player.skill28);
	digits(35, 125, "Timer: %01.3f", "Verdana#24", 0.0625, Stoppuhr);
	
	digits(200, 2220, "           YOU\n won with a time of\n      %01.3f secs\n   Congratulations!", "laCartoonerie#48", 0.0625, Stoppuhr);	
	digits(252, 4220, SAVE_Siegername, "laCartoonerie#48", 1, 0);
	digits(200, 4268, " won with a time of\n      %01.3f secs\n   Have a new try...", "laCartoonerie#48", 0.0625, Stoppuhr);
	layer = 1;
} // 6 // 7 (pltzl. Layer-Prob) Semis


// Count von oben bis hierhin: 14 // 15 (mit pltzl. Layer-Prob)  Semis
//////////////////////////
// Count von unten bis hierhin: 85 Semis


function Logo_EinAusblendung(Zaehlwert, Zielwert, Schritte) {
	while (sign(Schritte)*Zaehlwert < Zielwert) {
v(		Zaehlwert, Zaehlwert + 0.06 * Schritte * time_step,
		Logo.alpha, exp(Zaehlwert)*0.25 -0.5,		dummy,0);	// Zaehlwert min=0 & max=6
		wait(1);
	}
} // 2 Semis

function Signal(Verlauf, STRING* Begriff, STRING* Sound, PosX, PosY) {
	media_play(Sound, NULL, 100);
	while (Verlauf < 100) {
		draw_textmode("SF Wonder Comic",1,Verlauf,-Verlauf);
		draw_text(Begriff, PosX, PosY, vector(Verlauf,100,255));
		Verlauf += 3.5 * time_step;
		wait(1);
	}
} // 5 Semis

function Rennen_beenden(ENTITY* Sieger) {
	Signal(0, "Pfiff", "Source\\Sounds\\Trillerpfeif.wav", screen_size.x-240, screen_size.y-110);
v(	Rennen_aktiv, 0,
	Statusanzeige.pos_x, Logo.pos_x,
	Statusanzeige.pos_y, Logo.pos_y -2000);
	media_stop(Theme_handle);
	if ((Sieger._Rivale_Nr == 2) || (Sieger._Rivale_Nr == 3) || (Sieger._Rivale_Nr == 4)) Statusanzeige.red = 0;
	if ((Sieger._Rivale_Nr == 0) || (Sieger._Rivale_Nr == 4) || (Sieger._Rivale_Nr == 5)) Statusanzeige.green = 0;
	if ((Sieger._Rivale_Nr == 0) || (Sieger._Rivale_Nr == 1) || (Sieger._Rivale_Nr == 2)) Statusanzeige.blue = 0;
	if (Sieger == player) {
		media_play("Source\\Sounds\\Jubel.wav", NULL, 75);
v(		SpSAVE_Siegerzeit_i, Stoppuhr,
		MapSpielerKontrolle_i, (ent_for_name("Goal")).x,		dummy,0);
		 if (str_stri(command_str,"-Name#") > 0) {
			 player.string1 = command_str;
			 str_clip(player.string1, str_stri(player.string1,"-Name#")+5);
		 } else {
		 	 player.string1 = "noname";
		 }
		 str_cpy(SAVE_Siegername, "                ");
		 str_cat(SAVE_Siegername, player.string1);
		 str_clip(SAVE_Siegername, str_len(SAVE_Siegername)/2 +0.5);
		game_save(player.string1, 0, SV_INFO + SV_STRINGS);
	} else {
		media_play("Source\\Sounds\\Oooh.wav", NULL, 75);
		game_load("KoFRival", Sieger._Rivale_Nr);
v(		Stoppuhr, RiLOAD_Siegerzeit[Sieger._Rivale_Nr],
		Statusanzeige.pos_y, Statusanzeige.pos_y -2000,		dummy,0);
	}
	Logo.bmap = bmap_create("LogoWinner.pcx");
	Logo_EinAusblendung(0, 6, 1);
	while (mouse_left != 1) wait(1);
	sys_exit("Goodbye!");
} // 22

//////////////////////////

function Sprungbewegung(StreckenInsgesamtlaenge) {
	set(my,_Bew_ImSprung);	
v(	my._Bew_Sprunghoehe_max, ((StreckenInsgesamtlaenge/2)*(StreckenInsgesamtlaenge/2))/40,
	my._Bew_StreckenRest, StreckenInsgesamtlaenge,
	my._Bew_SprungBahnHoehe, my.z);
	while (my._Bew_StreckenRest >= 0) {
v(		my.x, my.x + 10*time_step,
		my.z, (sin((180*my._Bew_StreckenRest)/StreckenInsgesamtlaenge) * my._Bew_Sprunghoehe_max + my._Bew_SprungBahnHoehe),
		my._Bew_StreckenRest, my._Bew_StreckenRest - 10*time_step		);
		if ((my.x > (ent_for_name("Goal")).x) && (Rennen_aktiv == 1)) {
			Rennen_beenden(me);
		}
		wait(1);
	}
	ent_playsound (me, snd_create("Swash.wav"), pow(StreckenInsgesamtlaenge,2)/50);
	reset(my,_Bew_ImSprung);
} // 7 Semis

action Rivale() {
	//per WED:	SHADOW + INVISIBLE & _Rivale_Nr gesetzt	
	while (Rennen_aktiv && (is(my,INVISIBLE)==0)) {
		while (Stoppuhr < RiLOAD_Spruenge[my._Sprung_Nr][1][my._Rivale_Nr]) {
			wait(1);
		}
		Sprungbewegung(RiLOAD_Spruenge[my._Sprung_Nr][0][my._Rivale_Nr]);
		wait_for_reset(my,_Bew_ImSprung);
		my._Sprung_Nr++;
	}
} // 4 Semis

action Spieler() {
	//per WED:	SHADOW gesetzt & _Rivale_Nr=-1
	player = me;
	my._PowerSound = snd_loop(snd_create("FrogPower.wav"), 30, 0);
	while(Rennen_aktiv && (proc_status(Spieler)==1)) {
		while ((mouse_moving) && (mouse_force_x <= 0)) { 
			my._PowerRegul = clamp( (my._PowerRegul + (-mouse_force_x-0.1)*16*time_step),  0.01, 4);		// Funktion: lngere Beobachtung (Einfluss) der Mausbewegung / notwendig wegen mouse_moving welches 1/4sek "nachwirkt"
			my._Power += 0.001/(-mouse_force_x*10 + my._PowerRegul) *16*time_step;		
			// Sound
			snd_tune(my._PowerSound, ((2/(-mouse_force_x+0.01) * sign(-mouse_force_x) * time_step)+1)*30, my._Power+80, 0);
			wait(1);
		}
		if (mouse_force_x > 0) {
			while ((my._Mausbewegungsdauer < 30) && (my._Fehlbewegung < 10)) {
v(				my._Motivation, my._Motivation + (mouseforce_positiv*clamp(mickey_x/10, 1, 100)) *2*time_step,
				my._Mausbewegungsdauer, my._Mausbewegungsdauer + time_step,				dummy,0);
				
				if (mouse_force_x <= 0) {
					my._Fehlbewegung += time_step;
				} else {
					my._Fehlbewegung = 0;
				}
				wait(1);
			}
			if (my._Motivation >= 10) {
				my._Motivation += 30-(my._Mausbewegungsdauer-my._Fehlbewegung);
				my._Sprungweite = log(my._Power*11.5+10) * my._Motivation/4;
				// Sound
				snd_tune(snd_play(snd_create("FrogMotivat.wav"),100,NULL),0, -my._Sprungweite/4+105, 0);

				// [I] Speicherfunktion
v(				SpSAVE_Spruenge_i[SpSAVE_Sprunganzahl_i][0], my._Sprungweite,
				SpSAVE_Spruenge_i[SpSAVE_Sprunganzahl_i][1], Stoppuhr,
				
				SpSAVE_Sprunganzahl_i, SpSAVE_Sprunganzahl_i+1		);
				Sprungbewegung(my._Sprungweite);
				wait_for_reset(my,_Bew_ImSprung);
				
v(				my._PowerRegul, 0,
				my._Power, 0,		dummy,0);
				snd_tune(my._PowerSound, 30, 0, 0);
			}
v(			my._Motivation, 0,
			my._Mausbewegungsdauer, 0,
			my._Fehlbewegung, 0);
		}
		wait(1);
	}
	snd_stop(my._PowerSound);
} // 21 Semis


//////////////////////////

//#include "Source\\CodeExtra\\KoF_debug.c"

void main() {
	video_switch(SCREENRES+6, 0, 1);		// 1 = 800x600, 5 = 1600x1200	
v(	shadow_stencil, HQSHADOW,
	freeze_mode, 1,
	mouse_time, 1		);

v(	d3d_alpharef, 1,
	Logo.pos_x, (screen_size.x-800)/2, 		// =>LogoGre
	Logo.pos_y, (screen_size.y-600)/2		);

	level_load (str_cat_num(str_create("KoFmap"), "%0.f.wmb", LEVEL));
	wait(2);
	
	Theme_handle = media_loop (str_cat_num(str_create("Source\\\\Sounds\\\\KoFtheme"), "%0.f.mid", THEME), NULL, 40);		// Darf nicht hinter game_load stehen, sonst ist sein Result falsch! (liegt wohl an "[str]_create")
	
	// Mitspieler erstellen
	for (Rivale_Nr=0; Rivale_Nr < 6; Rivale_Nr++) {
		if (game_load("KoFRival", Rivale_Nr) > 0) {		// fllt "SpSAVE_*", sofern SAV-Datei gefunden, mit Daten
			you = ent_for_name(str_cat_num(str_create("Rival_"), "%0.f", Rivale_Nr+1));
			if (MapSpielerKontrolle_i == (ent_for_name("Goal")).x) {
v(				RiLOAD_Siegerzeit[Rivale_Nr], SpSAVE_Siegerzeit_i,
				RiLOAD_Sprunganzahl[Rivale_Nr], SpSAVE_Sprunganzahl_i,		dummy,0);
				for (Sprung_Nr=0; Sprung_Nr<=RiLOAD_Sprunganzahl[Rivale_Nr] -1; Sprung_Nr++) {
v(					RiLOAD_Spruenge[Sprung_Nr][0][Rivale_Nr], SpSAVE_Spruenge_i[Sprung_Nr][0],						// Distanz laden/bernehmen
					RiLOAD_Spruenge[Sprung_Nr][1][Rivale_Nr], SpSAVE_Spruenge_i[Sprung_Nr][1],		dummy,0);	// Zeitpunkt laden/bernehmen
				}
				your.skin = your._Rivale_Nr+2;
				reset(your,INVISIBLE);
			} else {
				printf("Loaded enemy doesn't fit to map!");
			}
		}
	}
	while (mouse_left != 1) wait(1);
	Logo_EinAusblendung(6, 0, -1);
	Signal(0, "*PENG!*", "Source\\Sounds\\Startschuss.wav", 240, 90);
	set(Statusanzeige, VISIBLE);
v(	SpSAVE_Sprunganzahl_i, 0,
	Rennen_aktiv, 1,
	freeze_mode, 0		);
	while (Rennen_aktiv) {
v(		midi_vol, 100,
		Stoppuhr, Stoppuhr+time_step,		dummy,0);
		wait(1);
		if (key_esc) sys_exit("Breakup");
	}
} // 24 Semis

//////////////////////////////

